<?php

/**
 * AdminStatusEstoque.class [ MODEL ADMIN ]
 * Responsável por gerenciar as status_estoques do sistema no admin!
 * 
 * @copyright (c) 2017, Welton Thierree TagPage
 */
class AdminStatusEstoque {

    private $Data;
    private $SeId;
    private $Error;
    private $Result;

    //Nome da tabela no banco de dados
    const Entidy = 'tp_status_estoque';

    public function ExeCreate(array $Data) {
        $this->Data = $Data;

        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ['<b>Erro ao cadastrar</b> Para cadastrar um status de estoque, preencha todos os campos', WS_ALERT];
        else:
            $this->Create();
        endif;
    }

    public function ExeUpdate($StatusEstoqueId, array $Data) {
        $this->SeId = (int) $StatusEstoqueId;
        $this->Data = $Data;

        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ["<b>Erro ao atualizar</b> Para cadastrar a status_estoque {$this->Data['status_estoque_titulo']}, preencha todos os campos", WS_ALERT];
        else:
            $this->Update();
        endif;
    }

    public function ExeDelete($status_estoqueId) {
        $this->SeId = (int) $status_estoqueId;

        $read = new Read;
        $read->ExeRead(self::Entidy, "WHERE status_estoque_id = :id", "id={$this->SeId}");

        if (!$read->getResult()):
            $this->Result = false;
            $this->Error = ['Oppss, você tentou remover um status de estoque que não existe no sistema!', WS_INFOR];
        else:
            extract($read->getResult()[0]);
            if (!$this->checkProdutos()):
                $this->Result = false;
                $this->Error = ["O <b>status {$status_estoque_nome}</b> possui produtos cadastrados. para deletar, antes altere ou remova os produtos!", WS_ALERT];
            else:
                $delete = new Delete;
                $delete->ExeDelete(self::Entidy, "WHERE status_estoque_id = :deletaid", "deletaid={$this->SeId}");
                
                $this->Result = true;
                $this->Error = ["O <b>Status {$status_estoque_nome}</b> foi removido com sucesso!", WS_ACCEPT];
            endif;
        endif;
    }

    function getResult() {
        return $this->Result;
    }

    function getError() {
        return $this->Error;
    }

    //PRIVATES
    private function setData() {
        $this->Data = array_map('strip_tags', $this->Data);
        $this->Data = array_map('trim', $this->Data);   
    }

    private function checkProdutos() {
        $readPost = new Read;
        $readPost->ExeRead("tp_produtos", "WHERE produto_estoque_esgotado = :status_estoque", "status_estoque={$this->SeId}");
        if ($readPost->getResult()):
            return false;
        else:
            return true;
        endif;
    }

    private function Create() {
        $Create = new Create;
        $Create->ExeCreate(self::Entidy, $this->Data);
        if ($Create->getResult()):
            $this->Result = $Create->getResult();
            $this->Error = ["<b>Sucesso:</b> O status_estoque {$this->Data['status_estoque_titulo']} foi cadastrado no sistema", WS_ACCEPT];
        endif;
    }

    private function Update() {
        $Update = new Update;
        $Update->ExeUpdate(self::Entidy, $this->Data, "WHERE status_estoque_id = :catid", "catid={$this->SeId}");
        if ($Update->getResult()):
            $tipo = (empty($this->Data['status_estoque_parente']) ? 'seção' : 'status_estoque');
            $this->Result = true;
            $this->Error = ["<b>Sucesso:</b> A {$tipo} {$this->Data['status_estoque_nome']} foi atualizada no sistema", WS_ACCEPT];
        endif;
    }

}
